package	jp.co.sds_corp.report.tool;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Iterator;

import jp.co.sds_corp.report.IReport;
import jp.co.sds_corp.report.ReportFactory;
import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogger;

public class Main
{
	static CmnLogger logger = CmnLogger.getInstance();
	String outfile;

	public static void main( String[] args ) {
		try {
			if ( args.length < 2 ) {
				System.err.println( "usage: Main [Target] [file]" );
				System.exit( 9 );
			}
			Main obj = new Main();
			obj.print( args[0], args[1] );
		} catch ( Exception ex ) {
			ex.printStackTrace();
			System.exit( 9 );
		}
	}

	public void print( String target, String result ) throws Exception {
		String file = System.getProperty( "report.config" );
		DOMConfiguration config = new DOMConfiguration( file );
		IConfiguration c = null;
		Iterator<IConfiguration> itr = config.getChilds( "Report" );
		while ( itr.hasNext()) {
			IConfiguration tmp = (IConfiguration )itr.next();
			String name = tmp.getAttributes().get( "name", null );
			if ( name != null && name.equals( target )) {
				c = tmp;
				break;
			}
		}
		if ( c == null ) {
			throw( new Exception( "target not found. [" + target + "]" ));
		}
		IReport	report = ReportFactory.createReport( c );
		if ( result.indexOf( "." ) < 0 ) {
			outfile = result + "." + report.getExtension();
		} else {
			outfile = result;
		}
		if ( report.isDebug()) {
			logger.debug( this, "print " + target + "->" + outfile );
		}

		FileOutputStream out = new FileOutputStream( new File( outfile ));
		report.print( out );
		out.flush();
		out.close();
	}

}
